<template>
    <div>
        <el-card class="box-card" shadow="always" :body-style="{ height: bodyHeight }" style="overflow-y: auto;">
          <div slot="header" class="clearfix">
            <span>{{ title }}</span>
            <el-button-group style="float: right;">
              <el-button size="mini" icon="el-icon-plus" round @click="submitForm">保存</el-button>
              <el-button size="mini" icon="el-icon-back" round @click="showCard">返回</el-button>
            </el-button-group>
          </div>
          <el-form ref="form" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="上级部门" prop="parentId">
              <treeselect v-model="form.parentId" :options="deptOptions" :normalizer="normalizer" placeholder="请选择上级部门" />
            </el-form-item>
            <el-form-item label="部门名称" prop="deptName">
              <el-input v-model="form.deptName" placeholder="请输入部门名称" />
            </el-form-item>
            <el-form-item label="部门编码" prop="deptNo">
              <el-input v-model="form.deptNo" placeholder="请输入部门编码" />
            </el-form-item>
            <el-form-item label="状态" prop="status">
              <el-radio-group v-model="form.status">
                <el-radio
                  v-for="dict in statusOptions"
                  :key="dict.id"
                  :label="dict.itemText"
                >{{dict.itemValue}}</el-radio>
              </el-radio-group>
            </el-form-item>
            <el-form-item label="备注" prop="remark">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
            </el-form-item>
          </el-form>
        </el-card>
    </div>
</template>

<script>
import { getDept, listDept, updateDept } from '@/api/system/dept'
import { construct } from '@/utils/json-tree'
import Treeselect from "@riophae/vue-treeselect"
import "@riophae/vue-treeselect/dist/vue-treeselect.css"

export default {
  name: 'DeptEdit',
  components: { Treeselect },
  props: {
    data: {
      type: Object,
      default: function() {
        return {}
      }
    }
  },
  data () {
    return {
      bodyHeight: document.body.offsetHeight - 130 + 'px',
      title: '部门编辑',
      // 展示切换
      showOptions: {
        data: {},
        showList: true,
        showAdd: false,
        showEdit: false,
        showDetail: false
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        parentId: [
          { required: true, message: "上级部门不能为空", trigger: "blur" }
        ],
        deptName: [
          { required: true, message: "部门名称不能为空", trigger: "blur" }
        ],
        deptNo: [
          { required: true, message: "部门编码不能为空", trigger: "blur" }
        ]
      },
      // 状态数据字典
      statusOptions: [],
      // 部门树选项
      deptOptions: []
    }
  },
  created () {
    console.log('id:' + this.data.id)
    this.getDicts("sys_common_status").then(response => {
      if (response.success) {
        this.statusOptions = response.data
      }
    })
    this.getDeptTreeSelect()
    this.getDept(this.data.id)
  },
  methods: {
    showCard () {
      this.$emit('showCard', this.showOptions)
    },
    getDeptTreeSelect: function() {
      listDept().then(response => {
        if (response.success) {
          const { data } = response
          this.deptOptions = []
          const dept = { id: '0', deptName: '主类目', children: [] }
          dept.children = construct(data, {
            id: 'id',
            pid: 'parentId',
            children: 'children'
          })
          this.deptOptions.push(dept)
        }
      })
    },
    /** 转换部门数据结构 */
    normalizer (node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.id,
        label: node.deptName,
        children: node.children
      }
    },
    /** 获取详情 */
    getDept: function(id) {
      getDept(id).then(response => {
        if (response.success) {
          this.form = response.data
        }
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          updateDept(this.form).then(response => {
            if (response.success) {
              this.$message.success("保存成功")
              setTimeout(() => {
                // 2秒后跳转列表页
                this.$emit('showCard', this.showOptions)
              }, 2000)
            } else {
              this.$message.error("保存失败")
            }
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>

</style>
